
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android 逃离adapter的地狱－针对多个View type的组合实现方案 / iVAN</title>

    <meta name="description" content="Android 逃离adapter的地狱－针对多个View type的组合实现方案 英文原文:JOE'S GREAT ADAPTER HELL ESCAPE  本文地址:http://www.jcodecraeer.com/a/anzhuokaifa/androidkaifa/2015/0810/3282.html ,转载注明出处. 让我来告诉你一个关于乔某人的故事,一个在MyLittleZoo Inc工作的安卓开发者.关于他是如何从为具有多个view type的Adapter创建不同对象中解脱出来,最终成功实现可复用Adapter的. 曾经有一个叫做乔某某的人,它是一个安卓开">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Android 逃离adapter的地狱－针对多个View type的组合实现方案</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>英文原文：<a href="http://hannesdorfmann.com/android/adapter-delegates/" rel="external nofollow noreferrer">JOE'S GREAT ADAPTER HELL ESCAPE</a> </p>
<p>本文地址：<a href="http://www.jcodecraeer.com/a/anzhuokaifa/androidkaifa/2015/0810/3282.html" rel="external nofollow noreferrer">http://www.jcodecraeer.com/a/anzhuokaifa/androidkaifa/2015/0810/3282.html</a> ，转载注明出处。</p>
<p>让我来告诉你一个关于乔某人的故事，一个在MyLittleZoo Inc工作的安卓开发者。关于他是如何从为具有多个view type的Adapter创建不同对象中解脱出来，最终成功实现可复用Adapter的。</p>
<p>曾经有一个叫做乔某某的人，它是一个安卓开发者，为一家名叫MyLittleZoo Inc的初创公司工作。这是一家在网上销售宠物相关东西的公司。乔的工作是创建和维护一个与在线商店功能相同的安卓原生app。因此90%的开发工作都只是用RecyclerView显示一个列表。第一个版本1.0只需要显示一个配料列表，为此乔实现了一个AccessoiresAdapter，但是特别推荐的配料用item_accessory_offer.xml 显示，而普通配料则用item_accessory.xml显示。因此这个Adapter有两种View<br />
 type。在adapter中，view type可以让你为不容的item渲染不同的xml布局。在内部view type其实只是一个唯一的id，一个整型。因此乔的AccessoiresAdapter大致是这样实现的：</p>
<pre>public class AccessoiresAdapter extends RecyclerView.Adapter {

  final int VIEW_TYPE_ACCESSORY = 0;
  final int VIEW_TYPE_ACCESSORY_SPECIAL_OFFER = 1;

  List&lt;Accessory&gt; items;

  @Override public int getItemViewType(int position) {
     Accessory accessory = items.get(postion);
     if (accessory.hasSpecialOffer()){
       return VIEW_TYPE_ACCESSORY_SPECIAL_OFFER;
     } else {
       return VIEW_TYPE_ACCESSORY;
     }
  }

  @Override public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
    if (VIEW_TYPE_ACCESSORY_SPECIAL_OFFER == viewType){
      return new SpecialOfferAccessoryViewHolder(inflater.inflate(R.layout.item_accessory_offer, parent));
    } else {
      return new AccessoryViewHolder (inflater.inflate(R.layout.item_accessory)):
    }
  }

  ...

}</pre>
<p>MyLittelZoo安卓app1.0发布在了play store上。一切看上去都还好，一直相安无事。</p>
<p>后来，MyLittelZoo变大了，app也是如此。乔需要实现一个新的启动Activity，这里需要显示不同item：NewsTeaser需要和配料显示在一起，所以他建立了HomeAdapter，因为HomeAdapter需要同时显示配料，所以他决定通过继承AccessoriesAdapter来重用之前的代码：</p>
<pre>public class HomeAdapter extends AccessoriesAdapter {

  final int VIEW_TYP_NEWS_TEASER = 2;

  @Override public int getItemViewType(int position) {
     if (items.get(position) instanceof NewsTeaser){
       return VIEW_TYP_NEWS_TEASER;
     } else {
       // accessories and special offers
       return super.getItemViewType(position);
     }
  }

  @Override public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
    if (VIEW_TYP_NEWS_TEASER == viewType){
      return new NewsTeaserItem( inflater.inflate(R.layout.item_news_teaser, parent));
    } else {
      // accessories and special offers
      return super.onCreateViewHolder(parent, viewType);
    }
  }

  ...
}</pre>
<p>同时还有一个新的只显示关于宠物食物的小建议的Activity需要实现，因此乔实现了PetFoodTipAdapter：</p>
<pre>public class PetFoodTipAdapter extends RecyclerView.Adapter {

  final int VIEW_TYP_FOOD_TIP = 0;

  @Override public int getItemViewType(int position) {
     return VIEW_TYP_FOOD_TIP;
  }

  @Override public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
    return new PetFoodViewHolder(inflater.inflate(R.layout.item_pet_food, parent))
  }

  ...

}</pre>
<p>因为他能按时交付，他的项目经理非常高兴。MyLittelZoo 2.0 成功发布在 Play Store上。</p>
<p>几周之后，产品经理跑来跟乔说，生意的发展不及预期。为了赚钱，gongsi决定和一家大广告公司签订一份协议。这家广告公司可以在MyLittleZoo的安卓app上展示横幅，换句话说：乔的公司把自己的灵魂出卖给了魔鬼。乔的工作是使用别人提供的广告sdk，把广告横幅包含在app中。时间紧迫，公司需要钱（从广告上收益）。app的更新必须尽快发布。因为广告横幅需要和RecyclerView中的其他的item显示在一起，乔决定创建一个名叫calledAdvertismentAdapter的基类adapter。</p>
<pre>public class AdvertismentAdapter extends RecyclerView.Adapter {

  final int VIEW_TYP_ADVERTISEMENT = 0;

  @Override public int getItemViewType(int position) {
     return VIEW_TYP_ADVERTISEMENT;
  }

  @Override public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
    return new AdvertismentViewHolder(inflater.inflate(R.layout.item_advertisment, parent))
  }

  ...

}</pre>
<p>从此，其他的所有adapter都继承自AdvertisementAdapter：</p>
<ul>
<li>AccessoiresAdapter 继承 AdvertisementAdapter</li>
<li>HomeAdapter 继承 AccessoiresAdapter 继承 AdvertisementAdapter</li>
<li>PetFoodTipAdapter 继承 AdvertisementAdapter</li>
</ul>
<p>到处充满广告的3.0 版本发布在了Play Store上。产品经理再次对乔的工作感到满意。</p>
<p>半年之后，产品经理再次敲响了乔的门，告诉他事情有了变化。MyLittleZoo 安卓app的用户不喜欢3.0版本中那些亮瞎人狗眼的广告横幅，app在play store上受到了大量的差评。访问量大减，公司不再盈利了。但是MyLittleZoo不能简单的从app中撤掉广告，因为他们和“魔鬼”签订了一个相当长的合同，魔鬼这里指的当然是广告公司。</p>
<p>然后MyLittleZoo市场部有个聪明的家伙，他想到了重启一个app项目，只在一个RecyclerView中显示NewsTeaser和PetFoodTip。没有广告，没有推荐。按计划是为了赢回用户的信任。再一次，产品经理告诉乔app需要在两天之内发布，因为在接下来的周末又一个很大的宠物节，app需要在届时呈现才行。乔认为这是可行的。他已经有了NewsTeaser和PetFoodTip的xml布局，adapter也已经是实现了的。因此乔只需把它们搬到一个library中，在原始的MyLittleZoo app和新的无广告版的advertisement<br />
 app中共享。</p>
<p>乔准备开始把东西搬到这个library，这时他意识到了此时面对的混乱境地：你还记得adapter的继承关系吗？</p>
<ol>
<li>每个adapter都继承自AdvertisementAdapter。但是新的app不需要显示广告。此外，显示横幅的广告sdk实在是太bug了，导致了太多的内存泄漏，经常崩溃。即使没有显示广告，sdk也还是在背后干很多事情。因此在新的app中包含广告sdk时不能接受的。</li>
<li>对于同时显示NewsTeaser（HomeAdapter的一部分）和PetFoodTip（PetFoodTipAdapter的一部分），没有可以重用的adapter。乔该怎么办呢？他可以创建一个新的NewsTipAdapter继承自HomeAdapter，然后把PetFoodTip作为一个心的view type添加进去。但是那就意味着对于同一个view type有两个adapter需要维护。</li>
</ol>
<h2>欢迎来到adapter的地狱，乔！</h2>
<p>可怜的娃儿，乔非常沮丧。沮丧过后是担忧。他该如何修复这个问题呢？他该如何修复才能避免一个月之后因为实现新功能（一个心的view type）而再次修复呢？</p>
<p>因此乔开始把自己的需求写在了白板上。但是没有想出什么办法。他很悲伤，他想到了自己的孩提时代，那个时候生活是多么轻松。那时候需要担心的唯一事情就是在耍完乐高以后清理自己的房间。乐高？等等！乔有了个聪明的主意：他真正需要的是像堆积乐高房子一样的构建自己的adapter：做好一个地基，然后把真正需要的乐高部件粘在一起。如果你的房子需要窗户，去取一个窗户部件；如果需要屋顶，取一个屋顶部件；如果需要后花园，取一朵花的部件。</p>
<p>靠，接着他就有了大致的图景：</p>
<blockquote><p>组合优于继承</p></blockquote>
<p>在和其他程序员讨论的时候，他不止一次同意“组合优于继承”的观点。在这之前，这对于他来说不过是一句口号而已，而现在他才真正根据这个准则构建出一点东西来。好了，一个空的adapter是地基。ViewType则是可重用的组件（乐高部件）。</p>
<p>因此乔开始定义可复用的乐高部件比如NewsTeaserAdapterDelegate和andPetFoodTipAdapterDelegate：</p>
<pre>public class NewsTeaserAdapterDelegate {

  private int viewType;

  public NewsTeaserAdapterDelegate(int viewType){
    this.viewType = viewType;
  }

  public int getViewType(){
    return viewType;
  }

  public boolean isForViewType(List items, int position) {
    return  items.get(position) instanceof NewsTeaser;
  }

  public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent) {
    return new NewsTeaserViewHolder(inflater.inflate(R.layout.item_news_teaser, parent, false));
  }

  public void onBindViewHolder(List items, int position, RecyclerView.ViewHolder holder) {
      NewsTeaser teaser = (NewsTeaser) items.get(position);
      NewsTeaserViewHolder vh = (NewsTeaserViewHolder) vh;

      vh.title.setText(teaser.getTitle());
      vh.text.setText(teaser.getText());
  }
}
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
public class PetFoodTipAdapterDelegate {

  private int viewType;

  public PetFoodTipAdapterDelegate(int viewType){
    this.viewType = viewType;
  }

  public int getViewType(){
    return viewType;
  }

  public boolean isForViewType(List items, int position) {
    return  items.get(position) instanceof PetFoodTip;
  }

  public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent) {
    return new PetFoodTipViewHolder(inflater.inflate(R.layout.item_pet_food, parent, false));
  }

  public void onBindViewHolder(List items, int position, RecyclerView.ViewHolder holder) {
      PetFoodTip tip = (PetFoodTip) items.get(position);
      PetFoodTipViewHolder vh = (NewsTeaserViewHolder) vh;

      vh.image.setImageRes(tip.getImage());
      vh.text.setText(tip.getText());
  }
}</pre>
<p>然后是地基，一个空的adapter，然后把乐高部件放在上面，创建NewsTipAdapter，在新app中使用：</p>
<pre>public class NewsTipAdapter extends RecyclerView.Adapter{

  final int VIEW_TYP_NEWS_TEASER = 0;
  final int VIEW_TYP_FOOD_TIP = 1;

  NewsTeaserAdapterDelegate newsTeaserDelegate;
  PetFoodTipAdapterDelegate foodTipDelegate;

  List items;

  public NewsTipAdapter(){
    newsTeaserDelegate = new NewsTeaserAdapterDelegate(VIEW_TYP_NEWS_TEASER);
    foodTipDelegate = new PetFoodTipAdapterDelegate(VIEW_TYP_FOOD_TIP);
  }

  @Override public int getItemViewType(int position) {
     if (newsTeaserDelegate.isForViewType(items, position)){
       return newsTeaserDelegate.getViewType();
     }
     else if (foodTipDelegate.isForViewType(items, position)){
       return foodTipDelegate.getViewType();
     }

     throw new IllegalArgumentException("No delegate found");
  }

  @Override public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {

    if (newsTeaserDelegate.getViewType() == viewType){
      return newsTeaserDelegate.onCreateViewHolder(parent);
    }
    else if (foodTipDelegate.getViewType() == viewType){
      return foodTipDelegate.onCreateViewHolder(parent);
    }

    throw new IllegalArgumentException("No delegate found");
  }

  @Override public void onBindViewHolder(VH holder, int position){
    int viewType = holder.getViewType();
    if (newsTeaserDelegate.getViewType() == viewType){
      newsTeaserDelegate.onBindViewHolder(items, position, holder);
    }
    else if (foodTipDelegate.getViewType == viewType){
      foodTipDelegate.onBindViewHolder(items, position, holder);
    }
  }
}</pre>
<p>我猜你应该看明白了。与使用继承不同，乔定为每个view type义了一个delegate。每个delegate负责创建和绑定ViewHolder。就如你看到的，上面的代码片段有许多散乱的代码。乔发现了一个插件式的解决办法：</p>
<pre>/**
 * @param &lt;T&gt; the type of adapters data source i.e. List&lt;Accessory&gt;
 */
public interface AdapterDelegate&lt;T&gt; {

  /**
   * Get the view type integer. Must be unique within every Adapter
   *
   * @return the integer representing the view type
   */
  public int getItemViewType();

  /**
   * Called to determine whether this AdapterDelegate is the responsible for the given data
   * element.
   *
   * @param items The data source of the Adapter
   * @param position The position in the datasource
   * @return true, if this item is responsible,  otherwise false
   */
  public boolean isForViewType(@NonNull T items, int position);

  /**
   * Creates the  {@link RecyclerView.ViewHolder} for the given data source item
   *
   * @param parent The ViewGroup parent of the given datasource
   * @return The new instantiated {@link RecyclerView.ViewHolder}
   */
  @NonNull public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent);

  /**
   * Called to bind the {@link RecyclerView.ViewHolder} to the item of the datas source set
   *
   * @param items The data source
   * @param position The position in the datasource
   * @param holder The {@link RecyclerView.ViewHolder} to bind
   */
  public void onBindViewHolder(@NonNull T items, int position, @NonNull RecyclerView.ViewHolder holder);
}
</pre>
<p><pre>public class AdapterDelegatesManager&lt;T&gt; {

  public AdapterDelegatesManager&lt;T&gt; addDelegate(@NonNull AdapterDelegate&lt;T&gt; delegate) {
    ...
  }

  public int getItemViewType(@NonNull T items, int position) {
    ...
  }

  public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
    ...
  }

  public void onBindViewHolder(@NonNull T items, int position, @NonNull RecyclerView.ViewHolder viewHolder) {
    ...
  }
}</pre>
<p>这个办法就是把AdapterDelegate注册到一个AdapterDelegatesManager。AdapterDelegatesManager内部有决定不同view type采取何种AdapterDelegate的逻辑与调用相应的delegate方法。应用到NewsTipAdapter中的代码大致如下：</p>
<pre>public class NewsTipAdapter extends RecyclerView.Adapter{

  final int VIEW_TYP_NEWS_TEASER = 0;
  final int VIEW_TYP_FOOD_TIP = 1;

  List items;

  AdapterDelegatesManager delegates = new AdapterDelegatesManager();

  public NewsTipAdapter(){
    delegates.add(new NewsTeaserAdapterDelegate(VIEW_TYP_NEWS_TEASER));
    delegates.add(new PetFoodTipAdapterDelegate(VIEW_TYP_FOOD_TIP));
  }

  @Override public int getItemViewType(int position) {
     return delegates.getItemViewType(items, position);
  }

  @Override public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
    return delegates.onCreateViewHolder(parent, viewType);
  }

  @Override public void onBindViewHolder(VH holder, int position){
      delegates.onBindViewHolder(items, position, holder);
  }
}</pre>
<p>我猜你应该能想象MyLittleZoo app其它adapter的样子了。总共有AdvertisementAdapterDelegate, NewsTeaserAdapterDelegate, PetFoodTipAdapterDelegate 和AccessoryAdapterDelegate。从此adapter可以通过那些真正需要的view type（AdapterDelegate）来组合。另外一个好处是你将inflating布局，创建view holder，绑定view holder的过程从adapter中分离出来，成了单独的，模块化的，可复用的AdapterDelegate。你有注意到现在adapter看起来是多了小巧吗？你可分散注意力到扩展性和降低耦合上面来了。另一个附加效果就是更多的团队成员可以在adapter上协同工作，而不用担心复杂的融合问题，因为不是每个人都接触庞大的adapter文件，而是团队成员同时专注于不同的AdapterDelegate<br />
 文件。</p>
<p>乔非常高兴，产品经理也非常高兴，用户也非常高兴，大家都非常高兴。（老外就是哆嗦！）。乔决定把这些AdapterDelegate放在自己的library中，并且开源，真是皆大欢喜。</p>
<p><a href="https://github.com/sockeqwe/AdapterDelegates" rel="external nofollow noreferrer">你可以在github上找到这些AdapterDelegate</a> ，同时也可以在maven central找到。</p>
<p>ps：AdapterDelegate library还提供了一个基类ListDelegationAdapter，它已经把RecyclerView.Adapter 的方法和AdapterDelegatesManager的方法放在了一起，因此你可以进一步减少代码：</p>
<pre>public class NewsTipAdapter extends ListDelegationAdapter {

  final int VIEW_TYP_NEWS_TEASER = 0;
  final int VIEW_TYP_FOOD_TIP = 1;

  public NewsTipAdapter(){
    // delegatesManager is a field defined in super class
    delegatesManager.add(new NewsTeaserAdapterDelegate(VIEW_TYP_NEWS_TEASER));
    delegatesManager.add(new PetFoodTipAdapterDelegate(VIEW_TYP_FOOD_TIP));
  }

}</pre>
<p>更详细的内容情查看<a href="https://github.com/sockeqwe/AdapterDelegates" rel="external nofollow noreferrer">Github</a> 上的library。</p>
<p>声明：乔和MyLittleZoo Inc都不是真实的。请注意本文涉及到的代码片段可能无法编译。它们是java版的伪代码，用于描述真实代码的大致样子。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-18 01:20:34</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Android 逃离adapter的地狱－针对多个View type的组合实现方案的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVN9xKz.html" rel="bookmark">代码-Android自定义Adapter重写的getView&lpar;&rpar;不执行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Android自定义Adapter重写的getView()不执行 想写个邮箱自动补全直接用了系统的下拉菜单 这是Adapter的代码 getView()方法不执行 解决方案 请参考 http://blog.csdn.net/ye_scofield/article/details/39252833 解决方案二: @Overridepublic int getCount() { // TODO Auto-generated method stub return bills.size();}			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjQPk5z.html" rel="bookmark">android listview adapter</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android listview adapter lv.setAdapter(new ArrayAdapter(thisandroid.R.layout.simple_list_item_1 strs));其中lv是一个listview的对象,已获取lv的id,strs是已定义的字符串数组,现在只要添加这句,程序不报错,但是运行错误,删除这句就能运行了 解决方案 把错误发上来把错误发上来 解决方案二: 12-28 21:25:58.529 938-938/com.example.adm			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWlZ3Xp.html" rel="bookmark">android ListView Adapter不显示</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android ListView Adapter不显示 //activity package wk.bluetooth; import android.app.Activity; import android.bluetooth.BluetoothAdapter; import android.bluetooth.BluetoothDevice; import android.bluetooth.BluetoothSocket; import android.content.Conte			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB1OAoz.html" rel="bookmark">修改按钮-Android中adapter数据传递出去与控制activity中按钮状态</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Android中adapter数据传递出去与控制activity中按钮状态 1C 求大神告知,我在adapter中获得了数据,是一个List 现在我在包适配器的这个activity中要用这个List如何将数据传递到activity中去呢?或者说我在activity中如何调用这个数据呢?还有一个问题,我在adapter中 viewHolder.imageIsCheck.setTag(position); convertView.setOnClickListener(new Content			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAVAy2p.html" rel="bookmark">Tesla公司还是针对先前的起火事故发布了补救方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				虽然Musk坚称Model S的安全性绝对有保证,今天Tesla公司还是针对先前的起火事故发布了补救方案. Musk在文章中细数了新款钛合金防护壳以及铝合金偏转板对车身的保护作用,所有在3月6日之后生产的汽车都将采用这种新的安全系统,而现有车型也可以免费添加. 这项举措或将杜绝先前Model S起火事故的再度发生,在那些碰撞事故中,电池的保护罩在汽车高速行驶撞击到金属物体时不具备很好的保护作用.而现在添加保护电池组的四分之一英寸弹道级铝合金装甲板之后,Model S将再多一层保护. 嘀嘀打车宣布			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvGQENp.html" rel="bookmark">layout-在 android 中如何放置text views和image view？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 在 android 中如何放置text views和image view? 我想在android应用中获得以下的效果: 背景图片我使用一个nine-patch png图片.我用一个text view 来实现: &lt;ImageView android:id=&quot;@+id/myImageView&quot; android:layout_width=&quot;wrap_content&quot; android:layout_height=&quot;wrap_content&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1l295b.html" rel="bookmark">不显示里面view的内容-android 我在使用ScrollView 中 加入画板view 无法显示&quest;&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android 我在使用ScrollView 中 加入画板view 无法显示?? android:layout_width=&quot;wrap_content&quot; android:layout_height=&quot;wrap_content&quot; &gt; android:background=&quot;#FFFFFF&quot; android:layout_width=&quot;match_parent&quot; android:layout_height=&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4NmANM.html" rel="bookmark">android 如何向布局指定位置动态插入view</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android 如何向布局指定位置动态插入view view是如何做到在光标处插入的? 如果用layout.addView(view child,int index),如果当前布局的所有view都是动态插入的,那这个index该怎么填? 解决方案 动态添加而且在光标之后的话,那么你选用的布局应该是RelativeLayout,可以给你新添加的view设置布局参数,实例化一个relativelayout,用参数定位你要添加的view的位置,然后调用view.setLayoutParams			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4Na3PM.html" rel="bookmark">Android开源项目第一篇&mdash;&mdash;个性化控件&lpar;View&rpar;篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文为那些不错的Android开源项目第一篇--个性化控件(View)篇,主要介绍Android上那些不错个性化的View,包括ListView.ActionBar.Menu.ViewPager.Gallery.GridView.ImageView.ProgressBar及其他如Dialog.Toast.EditText.TableView.Activity Animation等等. 本文中你可以找到那些精美App中各种有特性的View,如Gmail的左滑出菜单.Google plus的卡片式L			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKYZdp.html" rel="bookmark" class="title">spring-Spring  的 s标志 符号 时有时无</a>
					<div>
						问题描述 Spring 的 s标志 符号 时有时无 解决方案 没事的,只要运行没问题,这个s过一会儿就回来了. 解决方案二: 你这个applicationContext.xml好像本身就配错了,要不然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzw5W5M.html" rel="bookmark" class="title">jquery实现带单选按钮的表格行选中时高亮显示</a>
					<div>
						如果将选中的这条记录的行高亮显示,同时该行的单选按钮也被选中了,这样会提高用户的体验的,于是本文下了个示例,有需要的朋友可以参考下   上篇博客写的是复选框的,这次写的是单选框的,有时查询的时候,只能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJ2Rwz.html" rel="bookmark" class="title">Request&period;ServerVariables应用</a>
					<div>
						本机ip:&lt;%=request.servervariables(&quot;remote_addr&quot;)%&gt;服务器名:&lt;%=Request.ServerVariables(& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBn0ab.html" rel="bookmark" class="title">用&period;net动态创建类的实例</a>
					<div>
						用.net动态创建类的实例 看了网上很多关于DotNet动态创建类的实例的文章,我这里想总结一下,其实方法很简单,就是用&quot;Activator.CreateInstance&quot;.但是这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEllyoz.html" rel="bookmark" class="title">Asp&period;Net系列：两条语句实现Repeater通用的Ajax分页&lbrack;XCallback vs JQ in Ajax&rsqb;</a>
					<div>
						这篇文章将通过Repeater的Ajax分页示例,讲解Ajax的另一个框架 XCallback.当然不管你是哪个 Ajax框架的粉丝,这种分页都很实用,你可以使适用与你喜欢的框架, 毕竟大家都喜欢re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAm7Ob.html" rel="bookmark" class="title">PS路径工具中运算属性的应用</a>
					<div>
						教程介绍所有路径工具如钢笔,椭圆工具,矩形工具等多个路径叠加技巧.只要我们预先设置好路径的叠加属性,就可以非常快捷的制作出一些较为复杂的图形效果.图1是一只小熊头像的一部分,图1最左侧是参与运算的路径 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxd9Wb.html" rel="bookmark" class="title">oracle case when的使用方法</a>
					<div>
						Case when 的用法,简单Case函数 简单CASE表达式,使用表达式确定返回值. 语法: CASE search_expression WHEN expression1 THEN result ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrY84p.html" rel="bookmark" class="title">Excel2010的窗口怎么冻结</a>
					<div>
						  Excel2010的窗口怎么冻结           步骤 打开Excel工作表,如果要冻结&quot;A1&quot;行,那么我们就要选中&quot;A2&quot;单元格 在菜单栏单击&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNEgA7b.html" rel="bookmark" class="title">音量图标不见了怎么办</a>
					<div>
						我们在安装了新系统后,声卡驱动器也安装了,却发现在桌面右下角的音量小图标消失,没有这个小图标不太方便我们调节音量的大小,音量小图标消失不再右下角有可能出现一下的三种原因. 第一种:声卡驱动不正确 声卡 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkG2B7p.html" rel="bookmark" class="title">excel打不开怎么办？</a>
					<div>
						  在我们的日常工作中,不少网友都会遇到excel表格打不开的问题,那么,excel表格打不开该怎么办呢?小编的建议是:可以先对excel表格进行修复,那么,excel表格怎么修复呢?今天,小编推荐两 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGWA6p.html" rel="bookmark" class="title">怎样在Word2013中设置SmartArt文字环绕</a>
					<div>
						  第1步,打开Word2013文档窗口,选中SmartArt图形. 第2步,在&quot;SmartArt工具/格式&quot;功能区中,单击&quot;排列&quot;分组中的&quot;自动换行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGnDjp.html" rel="bookmark" class="title">苹果笔记本怎么装Win7</a>
					<div>
						  准备工作: 首先准备U盘一个.u盘启动盘制作工具(小编这里使用的是U大师,其它的操作方法基本一样).还有就是一个GHOST版Win7系统,我们就不提供下载了,大家可以自行在网上搜索. 苹果笔记本装 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywQadz.html" rel="bookmark" class="title">ieee-tiny6410使用sdio无线模块连接wifi失败</a>
					<div>
						问题描述 tiny6410使用sdio无线模块连接wifi失败 插上无线模块可以搜到wifi,第一次连接时也成功了,但之后连接便会卡死.提示[root@FriendlyARM /]# ieee8021 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywlEvz.html" rel="bookmark" class="title">阿里云共建无锡鸿山飞凤平台一期亮相物联网博览会</a>
					<div>
						9月10日,2017世界物联网博览会在江苏无锡拉开帷幕,阿里巴巴集团携阿里云IoT及蚂蚁金服参会,与5300多家世界物联网科技名企共创物联未来.阿里巴巴集团董事局主席马云受邀发表主题演讲. 马云:物联 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxJNEb.html" rel="bookmark" class="title">重构自己的代码，减去重复的部分</a>
					<div>
						问题描述 重构自己的代码,减去重复的部分 在实际的项目中,有一个程序包含三个窗体,这三个窗体包含同一个模块(执行Sql插入的模块,由三个textBox和一个执行插入操作的按钮), sql语句如下: s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrkJ8M.html" rel="bookmark" class="title">河北省立法禁止利用网络制作并散布谣言</a>
					<div>
						中新网石家庄12月28日电(记者 黄芳)河北省人大法工委和河北省工信厅28日联合举行新闻发布会宣布,该省首部规范信息化建设和管理的地方性法规&lt;河北省信息化条例&gt;已经出台并将于2013年1月 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Qg3Ap.html" rel="bookmark" class="title">Nginx中的root&amp;amp&semi;alias文件路径及索引目录配置详解&lowbar;nginx</a>
					<div>
						root&amp;alias文件路径配置nginx指定文件路径有两种方式root和alias,这两者的用法区别,使用方法总结了下,方便大家在应用过程中,快速响应.root与alias主要区别在于ngi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQkRRp.html" rel="bookmark" class="title">Lotus添加图像资源的问题谁能救救我啊</a>
					<div>
						问题描述 在Lotus里添加图像资源来作为网页中的按钮,使网页更加美观.可是所写的命令不能用了,如果是用热点按钮,命令就能用例如:@Command([FileSave])保存的命令谁能救救我啊 解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmloAz.html" rel="bookmark" class="title">Struts1视频或者资料</a>
					<div>
						问题描述 求Struts1视频或者资料,因为公司现在要用到Struts1做项目,手上没资料,求各位大侠有没有这方面的资料,要全的哦!! 解决方案 解决方案二:我这里有,怎么给你啊,可以结贴了.我的邮箱 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWL31p.html" rel="bookmark" class="title">如何快速理解设计模式？</a>
					<div>
						问题描述 如何快速理解设计模式? 设计模式那么多,要怎么快速理解呢?又要在什么情况下使用.求大神指教. 解决方案 设计模式快速理解不了,这个东西需要不断的琢磨,没有一定的开发经验想快速理解也只能是理解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqmoKb.html" rel="bookmark" class="title">《Windows 8 开发权威指南：HTML5 和JavaScript卷》&mdash;&mdash;2&period;2 JavaScript概述</a>
					<div>
						2.2 JavaScript概述 2.2.1 什么是JavaScript 1．什么是脚本语言 脚本语言是一种应用程序扩展语言,用于系统的扩展,使其按用户的意愿去运行. 所有的基础功能由系统提供,脚本语 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXw84z.html" rel="bookmark" class="title">第一财经周刊：诺基亚的绿色魔方</a>
					<div>
						造出环保手机就算投身绿色事业了吗?在诺基亚看来,这还不过瘾,建一座绿色总部要更彻底些. 文|CBN记者 骆轶航 在手机生产中去除溴化物.三氧化二锑和氯化阻燃剂,及时切断&quot;零负荷&quot;的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGE833M.html" rel="bookmark" class="title">《精通 ASP&period;NET MVC 4》----1&period;2　当今的Web开发</a>
					<div>
						1.2 当今的Web开发 精通 ASP.NET MVC 4 除微软之外,自Web Form首次发布以来,Web开发技术发展迅速,这表现在几个不同的方向.除了Ajax之外,还有一些其他的主要发展. 1. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRvJmb.html" rel="bookmark" class="title">整顿BT下载网站，切忌矫枉过正</a>
					<div>
						&quot;在广电总局新一轮严查互联网视听许可证的风暴中,多家知名BT网站因为&quot;无证上岗&quot;而纷纷落马.广电总局的严打,再次给国内的视频网站敲响了警钟,除了BT类网站之后,视频分享以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7Ponp.html" rel="bookmark" class="title">Python 数字</a>
					<div>
						简述 在 Python 中,对于数字的定义很简单 - 整数.浮点数和复数,分别被定义为 int.float 和 complex 类.只要数学不是体育老师教的,绝大部分人学起来都不会有任何问题. 对于数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwyZZM.html" rel="bookmark" class="title">中石油投重金开发煤层气</a>
					<div>
						3月21日,中国石油(601857)在上海召开业绩说明会,公司财务总监周明春表示,&quot;十二五&quot;期间,公司将继续坚持&quot;资源.市场.国际化&quot;战略,突出集中发展油气主营 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwL9AM.html" rel="bookmark" class="title">请问ASP&period;NE使用最广的是什么版本？</a>
					<div>
						问题描述 大部分人都在用的,3还是3.5,我很久没用了. 解决方案 解决方案二:现在应该是4.0~4.5为主了吧解决方案三:之前2.0,后来升级到了4解决方案四:为什么大部分人都喝二锅头,茅台还敢称之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoj6xM.html" rel="bookmark" class="title">Yelp的实时流技术之三：不止是模式存储服务的Schematizer</a>
					<div>
						这是关于Yelp的实时流数据基础设施系列文章的第三篇.这个系列会深度讲解我们如何用&quot;确保只有一次&quot;的方式把MySQL数据库中的改动实时地以流的方式传输出去,我们如何自动跟踪表模式变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M120wap.html" rel="bookmark" class="title">给Notepad&plus;&plus; 6&period;7 加右键菜单带图标</a>
					<div>
						使用的是Notepad++ 6.7,下载 NppShell64.dll 和 NppShell.dll方法:将BAT文件和下载的NppShell64.dll 和 NppShell.dll放置Notepa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1NEd9p.html" rel="bookmark" class="title">国美&OpenCurlyDoubleQuote;见证低价奇迹&rdquo;价保十一最省钱</a>
					<div>
						国美在线以9月25日&quot;全场第二件起件件9折,仅此一天!&quot;拉开了&quot;见证低价奇迹&quot;促销的大幕后,还启动了一系列空前让利的http://www.aliyun.com/ ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
